package prj3part2;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;
import java.security.KeyFactory;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.X509EncodedKeySpec;
import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import javax.xml.bind.DatatypeConverter;

/****************************************************************************
 * The Client class is a client that connects to a server and is able
 * to get a list of other clients connected to the server, send a message to
 * an individual client or all clients at once, receive messages from the 
 * server, and kick selected clients from the server.
 * @author Kyle Hekhuis
 * @since 10/29/16
 *****************************************************************************/
public final class Client {
	
	/** Used to listen for updates to serverMessage. */
	private PropertyChangeSupport changes = new PropertyChangeSupport(this);
	/** Socket that client uses to connect to server. */
	private Socket clientSocket;
	/** Data output to server. */
	private DataOutputStream dos;
	/** Data input from server. */
	private DataInputStream dis;
	/** Message from the server. */
	private volatile String serverMessage;
	/** Public key of the server to use for encryption. */
	private PublicKey pubKey;
	/** Secret key generated by client to use for encryption. */
	private SecretKey secretKey;
	/** Initialization vector generated by client to use for encryption.  */
	private IvParameterSpec clientIV;
	/** Random generator to use for IV. */
	private SecureRandom r;
	/** Byte array to use for generating IV. */
	private byte[] ivbytes;
	
	/***************************************************************************
	 * Creates a Client object that connects to the server located at
	 * the passed IP and port number.
	 * @param ip IP of server to connect to
	 * @param port port number of server to connect to
	 * @throws Exception failed to create socket or create input/output stream
	 **************************************************************************/
	public Client(final String ip, final String port) throws Exception {
		clientSocket = new Socket(InetAddress.getByName(ip), Integer.parseInt(port));
		
		//Instantiate data streams
		dos = new DataOutputStream(clientSocket.getOutputStream());
	    dis = new DataInputStream(clientSocket.getInputStream());
		
	    //Set keys and IV
		setPublicKey("src/RSApub.der");
		secretKey = generateAESKey();
		r = new SecureRandom();
		ivbytes = new byte[16];
		
		//Send encrypted secret key and IV to server
		byte[] encryptedKey = RSAEncrypt(secretKey.getEncoded());
		sendBytes(encryptedKey);
		
		//Start listening to server
		ServerListener sl = new ServerListener();
		sl.start();
	}
	
	/*********************************************
	 * Ask the server for the IP of this client.
	 *********************************************/
	public void getClientIP() {
		//System.out.println("CLIENT: GET_IP HERE");
		sendToServer("#GET_IP#");
	}
	
	/****************************************************
	 * Ask the server for its list of connected clients.
	 ****************************************************/
	public void getClientList() {
		//System.out.println("CLIENT: GET_CLIENTS HERE");
		sendToServer("#GET_CLIENTS#");
	}
	
	/*************************************************
	 * Tells the server this client is shutting down.
	 *************************************************/
	public void exit() {
		try {
			//System.out.println("CLIENT: TERMINATE HERE");
			sendToServer("#TERMINATE#");
			clientSocket.close();
		} catch (IOException e) {}
	}
	
	/***********************************************************
	 * Ask the server to kick the client connected to it whose
	 * IP is the one passed.
	 * @param clientIP IP of client to kick from server
	 ***********************************************************/
	public void adminKick(final String clientIP) {
		//System.out.println("CLIENT: ADMIN_KICK HERE: " + clientIP);
		sendToServer("#ADMIN_KICK#" + clientIP);
	}
	
	/*********************************************************
	 * Sends the passed message to the server.
	 * @param message message to send to server
	 * @return true if message is successfully sent to server
	 *********************************************************/
	public boolean sendMessage(final String message) {
		//System.out.println("CLIENT: MESSAGE HERE: " + message);
		return sendToServer(message);
	}
	
	/***********************************************************
	 * Encrypts the passed message and then sends it to server.
	 * @param message message to be encrypted and sent
	 * @return true if message successfully encrypted and sent
	 ***********************************************************/
	private boolean sendToServer(final String message) {
		try {
			r.nextBytes(ivbytes);
			clientIV = new IvParameterSpec(ivbytes);
			sendBytes(clientIV.getIV());
			System.out.println("CLIENT: Unencrypted message: " + message);
			byte[] encryptedMessage = encrypt(message.getBytes(), secretKey, clientIV);
			System.out.println("CLIENT: Encrypted message: " + DatatypeConverter.printHexBinary(encryptedMessage));
			sendBytes(encryptedMessage);
			return true;
		} catch (IOException e) {
			return false;
		}
	}
	
	/***************************************************************
	 * Receives message from server, sets serverMessage to the
	 * received message, and then notifies anyone listening to this
	 * class that serverMessage has been updated.
	 ***************************************************************/
	private void receiveMessage() {
		serverMessage = "";
		String tempOldMessage = serverMessage.toString();
		IvParameterSpec serverIV;
		try {
			byte[] ivBytes = readBytes();
			serverIV = new IvParameterSpec(ivBytes);
			byte[] encryptedMessage = readBytes();
			byte[] decryptedMessage = decrypt(encryptedMessage, secretKey, serverIV);
			serverMessage = new String(decryptedMessage);
		} catch (IOException e) {
			serverMessage = null;
		}
		//Tells any listeners that serverMessage has been updated
		changes.firePropertyChange(new PropertyChangeEvent(this, "serverMessage", tempOldMessage, serverMessage));
	}
	
	/*********************************************************************************************************************
	 * Sends the passed byte array over the socket.
	 * @param myByteArray byte array to send to client
	 * @throws IOException if DataOutputStream write() fails
	 * @author Jason Plank  & Kevin Brock on StackOverflow
	 * https://stackoverflow.com/questions/2878867/how-to-send-an-array-of-bytes-over-a-tcp-connection-java-programming
	 **********************************************************************************************************************/
	private void sendBytes(byte[] myByteArray) throws IOException {
	    int len = myByteArray.length;
	    dos.writeInt(len);
	    if (len > 0) {
	        dos.write(myByteArray, 0, len);
	    }
	}
	
	/*******************************************************************************************************************
	 * Reads data sent to this socket.
	 * @return byte array of data read from socket
	 * @throws IOException if DataInputStream readFully() fails
	 * @author Jason Plank  & Kevin Brock on StackOverflow
	 * https://stackoverflow.com/questions/2878867/how-to-send-an-array-of-bytes-over-a-tcp-connection-java-programming
	 *******************************************************************************************************************/
	private byte[] readBytes() throws IOException {
	    int len = dis.readInt();
	    byte[] data = new byte[len];
	    if (len > 0) {
	        dis.readFully(data);
	    }
	    return data;
	}
	
	/***************************************
	 * Returns the message from the server.
	 * @return the message from the server
	 ***************************************/
	public String getMessage() {
		return serverMessage;
	}

	/************************************************************
	 * Adds a property change listener to this object.
	 * @param pcl property change listener to add to this object
	 ************************************************************/
	public void addPropertyChangeListener(final PropertyChangeListener pcl) {
        changes.addPropertyChangeListener(pcl);
    }

	/*****************************************************************
	 * Removes a property change listener from this object.
	 * @param pcl property change listener to remove from this object
	 ******************************************************************/
    public void removePropertyChangeListener(final PropertyChangeListener pcl) {
        changes.removePropertyChangeListener(pcl);
    }
    
    /******************************************************************
     * The ServerListener class is a thread that listens for messages
     * from the server this client is connected to.
     * @author Kyle Hekhuis
     * @since 10/1/16
     ******************************************************************/
    private final class ServerListener extends Thread {
		/**********************************
		 * Creates a ServerListener object.
		 **********************************/
		ServerListener() {}
		
		/***********************************************
		 * Constantly listens for messages from server.
		 ***********************************************/
		public void run() {
			while (true) {
				receiveMessage();
			}
		}
	}
    
    /*******************************************
	 * Sets the public key using RSApub.der
	 * @param filename file path for RSApub.der
	 * @author Andrew Kalafut
	 *******************************************/
    private void setPublicKey(final String filename){
		try {
		    File f = new File(filename);
		    FileInputStream fs = new FileInputStream(f);
		    byte[] keybytes = new byte[(int) f.length()];
		    fs.read(keybytes);
		    fs.close();
		    X509EncodedKeySpec keyspec = new X509EncodedKeySpec(keybytes);
		    KeyFactory rsafactory = KeyFactory.getInstance("RSA");
		    pubKey = rsafactory.generatePublic(keyspec);
		} catch (Exception e) {
		    System.out.println("Public Key Exception");
		    System.exit(1);
		}
    }
    
    /**************************************************
     * Generates a Secret key using AES key generator.
     * @return AES secret key
     * @author Andrew Kalafut
     **************************************************/
    private SecretKey generateAESKey() {
		try {
		    KeyGenerator keyGen = KeyGenerator.getInstance("AES");
		    keyGen.init(128);
		    SecretKey secKey = keyGen.generateKey();
		    return secKey;
		} catch (Exception e) {
		    System.out.println("Key Generation Exception");
		    System.exit(1);
		    return null;
		}
    }
    
    /*******************************************
     * Encrypts a byte array with a public key.
     * @param plaintext byte array to encrypt
     * @return encrypted byte array
     * @author Andrew Kalafut
     ******************************************/
    private byte[] RSAEncrypt(final byte[] plaintext) {
		try {
		    Cipher c = Cipher.getInstance("RSA/ECB/OAEPWithSHA-1AndMGF1Padding");
		    c.init(Cipher.ENCRYPT_MODE, pubKey);
		    byte[] ciphertext = c.doFinal(plaintext);
		    return ciphertext;
		} catch (Exception e) {
		    System.out.println("RSA Encrypt Exception");
		    System.exit(1);
		    return null;
		}
    }
    
    /***************************************************************************
     * Takes an unencrypted byte array and returns an encrypted version of it.
     * @param plaintext byte array to encrypt
     * @param secKey Secret key to use as part of cipher for encrypting
     * @param iv initialization vector to use as part of cipher for encrypting
     * @return encrypted byte array
     * @author Andrew Kalafut
     ***************************************************************************/
    private byte[] encrypt(final byte[] plaintext, final SecretKey secKey, final IvParameterSpec iv) {
		try {
		    Cipher c = Cipher.getInstance("AES/CBC/PKCS5Padding");
		    c.init(Cipher.ENCRYPT_MODE, secKey, iv);
		    byte[] ciphertext = c.doFinal(plaintext);
		    return ciphertext;
		} catch (Exception e) {
		    System.out.println("AES Encrypt Exception");
		    System.exit(1);
		    return null;
		}
    }
    
    /***************************************************************************
     * Takes an encrypted byte array and returns an unencrypted version of it.
     * @param ciphertext byte array to be decrypted
     * @param secKey Secret key to use as part of cipher for decrpyting
     * @param iv initialization vector to use as part of cipher for decrypting
     * @return decrypted byte array
     * @author Andrew Kalafut
     ***************************************************************************/
    private byte[] decrypt(byte[] ciphertext, SecretKey secKey, IvParameterSpec iv) {
		try {
		    Cipher c = Cipher.getInstance("AES/CBC/PKCS5Padding");
		    c.init(Cipher.DECRYPT_MODE, secKey, iv);
		    byte[] plaintext = c.doFinal(ciphertext);
		    return plaintext;
		} catch (Exception e) {
		    System.out.println("AES Decrypt Exception");
		    System.exit(1);
		    return null;
		}
    }
}